# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Automation::Mgmt::V2015_10_31
  module Models
    #
    # Definition of the activity parameter.
    #
    class ActivityParameter

      include MsRestAzure

      # @return [String] Gets or sets the name of the activity parameter.
      attr_accessor :name

      # @return [String] Gets or sets the type of the activity parameter.
      attr_accessor :type

      # @return [Boolean] Gets or sets a Boolean value that indicates true if
      # the parameter is required. If the value is false, the parameter is
      # optional.
      attr_accessor :is_mandatory

      # @return [Boolean] Gets or sets a Boolean value that indicates true if
      # the parameter is dynamic.
      attr_accessor :is_dynamic

      # @return [Integer] Gets or sets the position of the activity parameter.
      attr_accessor :position

      # @return [Boolean] Gets or sets a Boolean value that indicates true if
      # the parameter can take values from the incoming pipeline objects. This
      # setting is used if the cmdlet must access the complete input object.
      # false indicates that the parameter cannot take values from the complete
      # input object.
      attr_accessor :value_from_pipeline

      # @return [Boolean] Gets or sets a Boolean value that indicates true if
      # the parameter can be filled from a property of the incoming pipeline
      # object that has the same name as this parameter. false indicates that
      # the parameter cannot be filled from the incoming pipeline object
      # property with the same name.
      attr_accessor :value_from_pipeline_by_property_name

      # @return [Boolean] Gets or sets a Boolean value that indicates true if
      # the cmdlet parameter accepts all the remaining command-line arguments
      # that are associated with this parameter in the form of an array. false
      # if the cmdlet parameter does not accept all the remaining argument
      # values.
      attr_accessor :value_from_remaining_arguments

      # @return [String] Gets or sets the description of the activity
      # parameter.
      attr_accessor :description

      # @return [Array<ActivityParameterValidationSet>] Gets or sets the
      # validation set of activity parameter.
      attr_accessor :validation_set


      #
      # Mapper for ActivityParameter class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ActivityParameter',
          type: {
            name: 'Composite',
            class_name: 'ActivityParameter',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              is_mandatory: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isMandatory',
                type: {
                  name: 'Boolean'
                }
              },
              is_dynamic: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isDynamic',
                type: {
                  name: 'Boolean'
                }
              },
              position: {
                client_side_validation: true,
                required: false,
                serialized_name: 'position',
                type: {
                  name: 'Number'
                }
              },
              value_from_pipeline: {
                client_side_validation: true,
                required: false,
                serialized_name: 'valueFromPipeline',
                type: {
                  name: 'Boolean'
                }
              },
              value_from_pipeline_by_property_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'valueFromPipelineByPropertyName',
                type: {
                  name: 'Boolean'
                }
              },
              value_from_remaining_arguments: {
                client_side_validation: true,
                required: false,
                serialized_name: 'valueFromRemainingArguments',
                type: {
                  name: 'Boolean'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              validation_set: {
                client_side_validation: true,
                required: false,
                serialized_name: 'validationSet',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ActivityParameterValidationSetElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ActivityParameterValidationSet'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
