# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Automation::Mgmt::V2015_10_31
  module Models
    #
    # Definition of the dsc node type.
    #
    class DscNode < ProxyResource

      include MsRestAzure

      # @return [DateTime] Gets or sets the last seen time of the node.
      attr_accessor :last_seen

      # @return [DateTime] Gets or sets the registration time of the node.
      attr_accessor :registration_time

      # @return [String] Gets or sets the ip of the node.
      attr_accessor :ip

      # @return [String] Gets or sets the account id of the node.
      attr_accessor :account_id

      # @return [DscNodeConfigurationAssociationProperty] Gets or sets the
      # configuration of the node.
      attr_accessor :node_configuration

      # @return [String] Gets or sets the status of the node.
      attr_accessor :status

      # @return [String] Gets or sets the node id.
      attr_accessor :node_id

      # @return [String] Gets or sets the etag of the resource.
      attr_accessor :etag

      # @return [Array<DscNodeExtensionHandlerAssociationProperty>] Gets or
      # sets the list of extensionHandler properties for a Node.
      attr_accessor :extension_handler


      #
      # Mapper for DscNode class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DscNode',
          type: {
            name: 'Composite',
            class_name: 'DscNode',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              last_seen: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastSeen',
                type: {
                  name: 'DateTime'
                }
              },
              registration_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'registrationTime',
                type: {
                  name: 'DateTime'
                }
              },
              ip: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ip',
                type: {
                  name: 'String'
                }
              },
              account_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'accountId',
                type: {
                  name: 'String'
                }
              },
              node_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nodeConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'DscNodeConfigurationAssociationProperty'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              node_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nodeId',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              extension_handler: {
                client_side_validation: true,
                required: false,
                serialized_name: 'extensionHandler',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DscNodeExtensionHandlerAssociationPropertyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DscNodeExtensionHandlerAssociationProperty'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
