# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Automation::Mgmt::V2015_10_31
  module Models
    #
    # The parameters supplied to the create or update webhook operation.
    #
    class WebhookCreateOrUpdateParameters

      include MsRestAzure

      # @return [String] Gets or sets the name of the webhook.
      attr_accessor :name

      # @return [Boolean] Gets or sets the value of the enabled flag of
      # webhook.
      attr_accessor :is_enabled

      # @return [String] Gets or sets the uri.
      attr_accessor :uri

      # @return [DateTime] Gets or sets the expiry time.
      attr_accessor :expiry_time

      # @return [Hash{String => String}] Gets or sets the parameters of the
      # job.
      attr_accessor :parameters

      # @return [RunbookAssociationProperty] Gets or sets the runbook.
      attr_accessor :runbook

      # @return [String] Gets or sets the name of the hybrid worker group the
      # webhook job will run on.
      attr_accessor :run_on


      #
      # Mapper for WebhookCreateOrUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'WebhookCreateOrUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'WebhookCreateOrUpdateParameters',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              is_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.isEnabled',
                type: {
                  name: 'Boolean'
                }
              },
              uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.uri',
                type: {
                  name: 'String'
                }
              },
              expiry_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.expiryTime',
                type: {
                  name: 'DateTime'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.parameters',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              runbook: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.runbook',
                type: {
                  name: 'Composite',
                  class_name: 'RunbookAssociationProperty'
                }
              },
              run_on: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.runOn',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
